--- ${PACKAGE_NAME}
-- Nenue
-- 82 be813a9d99c08f425258d6912a50db99ac04fa9d
-- 82 be813a9d99c08f425258d6912a50db99ac04fa9d
-- Created: 3/30/2016 1:23 AM
local B = select(2,...).frame
local mod = B:RegisterModule("ObjectiveTracker", _G.VeneerObjectiveWrapper, 'BuffFrame')
local print = B.print('Objectives')

--------------------------------------------------------------------
--- Events that are handled by Blizzard_ObjectiveTracker
--------------------------------------------------------------------

-------------------------------------------------------------------
--- Function hooks for BlizzUI compatibility
-------------------------------------------------------------------
mod.AddQuestWatch = function(questID)
    mod:Update(0x00000003)
end

local Quest = mod.Quest
mod.RemoveQuestWatch = function(questIndex, ...)
  print('|cFFFF8800RemoveQuestWatch', questIndex, ...)

  local info = mod.Quest.LogInfo[questIndex]

  -- remove quest refs
  local block = Quest.QuestBlock[info.questID]
  Quest.QuestBlock[info.questID] = nil
  Quest.LogBlock[questIndex] = nil

  -- remove if they still match
  if Quest.WatchInfo[info.watchIndex] == info then
    print('cleaning dead WatchInfo entry')
    Quest.WatchInfo[info.watchIndex] = nil
  end

  mod:Update(OBJECTIVE_TRACKER_UPDATE_MODULE_QUEST)
end

mod.AddTrackedAchievement = function(cheevID)
  mod.CleanWidgets()
  mod:Update(OBJECTIVE_TRACKER_UPDATE_MODULE_ACHIEVEMENT)
end


mod.RemoveTrackedAchievement = function(cheevID)
  print('|cFFFF8800UntrackAchievement', cheevID)
  mod.CleanWidgets()
  mod:Update(OBJECTIVE_TRACKER_UPDATE_MODULE_ACHIEVEMENT)
end

mod.AcceptQuest = function()
  mod:Update(OBJECTIVE_TRACKER_UPDATE_MODULE_QUEST_ADDED)
end

mod.AbandonQuest = function()
  QuestPOIUpdateIcons()
  mod:Update(OBJECTIVE_TRACKER_UPDATE_MODULE_QUEST)
end
mod.TurnInQuest = function()
  QuestPOIUpdateIcons()
  mod:Update(OBJECTIVE_TRACKER_UPDATE_MODULE_QUEST)
end
mod.AddAutoQuestPopUp = function(...)
   mod:Update(OBJECTIVE_TRACKER_UPDATE_MODULE_AUTO_QUEST_POPUP)
end
mod.RemoveAutoQuestPopUp = function(...)
  mod:Update(OBJECTIVE_TRACKER_UPDATE_MODULE_AUTO_QUEST_POPUP)
end



mod.SetSuperTrackedQuestID = function(questID)
  --mod:Update()
end